<?php

namespace Cadoles\CoreBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Session\Session;
use Symfony\Component\HttpFoundation\Response;

use Cadoles\CoreBundle\Entity\Group;

class CoreController extends Controller
{
    public function homeAction(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $user=$this->getUser();
        $masteridentity=$this->getParameter("masteridentity");
        $masterurl=$this->getParameter("masterurl");
        $masterapikey=$this->getParameter("masterapikey");
        
        // Mes scrums / pads
        $myscrums=[];
        $myscrumgroups=[];
        $mypads=[];
        $mypadgroups=[];
        $mycalcs=[];
        $mycalcgroups=[];

        if($masteridentity=="Ninegate") {
            if(stripos($masterurl,"/")===0)
                $url="https://".$this->getParameter("weburl").$masterurl;
            else
                $url=$masterurl;
            
            $indomaine = (stripos($url,$this->getParameter("weburl"))!==false);


            if($user) {
                // Recherche des élèments de masterIdentify
                $headers = ['Accept' => 'application/json'];
                $query = [];

                /* si hor domaine on utilise le proxy si proxy il y a */
                if(!$indomaine) {
                    $PROXYactivate = $em->getRepository("CadolesCoreBundle:Config")->find("PROXYactivate")->getValue();
                    if($PROXYactivate) {
                        $PROXYserver    = $em->getRepository("CadolesCoreBundle:Config")->find("PROXYserver")->getValue();
                        $PROXYport      = $em->getRepository("CadolesCoreBundle:Config")->find("PROXYport")->getValue();                    
                        \Unirest\Request::proxy($PROXYserver, $PROXYport, CURLPROXY_HTTP, true);
                    }
                }

                // Récupération des informations utilisateurs issus du masteridentity
                $response = \Unirest\Request::post($url.'/rest/user/'.$user->getUsername(),$headers,["key"=>$masterapikey]);

                // Mes scrums / pads
                $myscrums=$em->getRepository("CadolesCoreBundle:Scrum")->findBy(["user"=>$this->getUser()]);
                $mypads=$em->getRepository("CadolesCoreBundle:Etherpad")->findBy(["user"=>$this->getUser()]);
                $mycalcs=$em->getRepository("CadolesCoreBundle:Ethercalc")->findBy(["user"=>$this->getUser()]);

                // Mise à jour du user
                $user->setAvatar($response->body->user->avatar);
                $user->setRole($response->body->user->role);
                $em->persist($user);
                $em->flush();

                // Mise à jour des groupes
                $groups=$response->body->groups;
                $mygroup=[];

                foreach($groups as $groupexternal) {
                    // Le groupe existe-t-il
                    $group=$em->getRepository("CadolesCoreBundle:Group")->findOneBy(["idexternal"=>$groupexternal->id]);
                    if(!$group)
                        $group = new Group();
                    $group->setIdexternal($groupexternal->id);
                    $group->setLabel($groupexternal->title);
                    $group->setFgtemplate(true);
                    $em->persist($group);
                    $em->flush();                

                    $myscrumgroups[$group->getId()] =$em    ->createQueryBuilder()
                                                            ->select('s')
                                                            ->from('CadolesCoreBundle:Scrum','s')
                                                            ->from('CadolesCoreBundle:Group','g')
                                                            ->where('g.id=:id')
                                                            ->andWhere('g MEMBER OF s.groups')
                                                            ->setParameter('id',$group->getId())
                                                            ->getQuery()->getResult();

                    $mypadgroups[$group->getId()] =$em      ->createQueryBuilder()
                                                            ->select('e')
                                                            ->from('CadolesCoreBundle:Etherpad','e')
                                                            ->from('CadolesCoreBundle:Group','g')
                                                            ->where('g.id=:id')
                                                            ->andWhere('g MEMBER OF e.groups')
                                                            ->setParameter('id',$group->getId())
                                                            ->getQuery()->getResult();

                    $mycalcgroups[$group->getId()] =$em     ->createQueryBuilder()
                                                            ->select('e')
                                                            ->from('CadolesCoreBundle:Ethercalc','e')
                                                            ->from('CadolesCoreBundle:Group','g')
                                                            ->where('g.id=:id')
                                                            ->andWhere('g MEMBER OF e.groups')
                                                            ->setParameter('id',$group->getId())
                                                            ->getQuery()->getResult();
                }

                $tmp=[];
                foreach($myscrumgroups as $myscrumgroup) {
                    foreach($myscrumgroup as $myscrum) {
                        if(!in_array($myscrum,$tmp)&&!in_array($myscrum,$myscrums)) {
                            array_push($tmp,$myscrum);
                        }
                    }
                }
                $myscrumgroups=$tmp;

                $tmp=[];
                foreach($mypadgroups as $mypadgroup) {
                    foreach($mypadgroup as $mypad) {
                        if(!in_array($mypad,$tmp)&&!in_array($mypad,$mypads)) {
                            array_push($tmp,$mypad);
                        }
                    }
                }
                $mypadgroups=$tmp;

                $tmp=[];
                foreach($mycalcgroups as $mycalcgroup) {
                    foreach($mycalcgroup as $mycalc) {
                        if(!in_array($mycalc,$tmp)&&!in_array($mycalc,$mycalcs)) {
                            array_push($tmp,$mycalc);
                        }
                    }
                }
                $mycalcgroups=$tmp;

                // Sauvegarde en session des groupes de l'utilisateur
                $this->get('session')->set("groups",$groups);

            }
        }
        else {
            if($user) {
                

                // Mes scrums / pads
                $myscrums=$em->getRepository("CadolesCoreBundle:Scrum")->findBy(["user"=>$user]);
                $mypads=$em->getRepository("CadolesCoreBundle:Etherpad")->findBy(["user"=>$user]);
                $mycalcs=$em->getRepository("CadolesCoreBundle:Ethercalc")->findBy(["user"=>$user]);

                // Scrum / pad partagé sur mes groupes
                $groups=$user->getGroups();
                foreach($groups as $groupinternal) {
                    $myscrumgroups[$groupinternal->getId()] =$em    ->createQueryBuilder()
                                                                    ->select('s')
                                                                    ->from('CadolesCoreBundle:Scrum','s')
                                                                    ->from('CadolesCoreBundle:Group','g')
                                                                    ->where('g.id=:id')
                                                                    ->andWhere('g MEMBER OF s.groups')
                                                                    ->setParameter('id',$groupinternal->getId())
                                                                    ->getQuery()->getResult();

                    $mypadgroups[$groupinternal->getId()] =$em      ->createQueryBuilder()
                                                                    ->select('e')
                                                                    ->from('CadolesCoreBundle:Etherpad','e')
                                                                    ->from('CadolesCoreBundle:Group','g')
                                                                    ->where('g.id=:id')
                                                                    ->andWhere('g MEMBER OF e.groups')
                                                                    ->setParameter('id',$groupinternal->getId())
                                                                    ->getQuery()->getResult();

                    $mycalcgroups[$groupinternal->getId()] =$em     ->createQueryBuilder()
                                                                    ->select('e')
                                                                    ->from('CadolesCoreBundle:Ethercalc','e')
                                                                    ->from('CadolesCoreBundle:Group','g')
                                                                    ->where('g.id=:id')
                                                                    ->andWhere('g MEMBER OF e.groups')
                                                                    ->setParameter('id',$groupinternal->getId())
                                                                    ->getQuery()->getResult();

                }

                // Scrum
                $tmp=[];
                foreach($myscrumgroups as $myscrumgroup) {
                    foreach($myscrumgroup as $myscrum) {
                        if(!in_array($myscrum,$tmp)&&!in_array($myscrum,$myscrums)) {
                            array_push($tmp,$myscrum);
                        }
                    }
                }

                $myscrumshareds =$em    ->createQueryBuilder()
                                        ->select('s')
                                        ->from('CadolesCoreBundle:Scrum','s')
                                        ->andWhere(':user MEMBER OF s.users')
                                        ->setParameter('user',$user)
                                        ->getQuery()->getResult();
                foreach($myscrumshareds as $myscrum) {
                    if(!in_array($myscrum,$tmp)&&!in_array($myscrum,$myscrums)) {
                        array_push($tmp,$myscrum);
                    }
                }
                        
                $myscrumgroups=$tmp;

                // Pad
                $tmp=[];
                foreach($mypadgroups as $mypadgroup) {
                    foreach($mypadgroup as $mypad) {
                        if(!in_array($mypad,$tmp)&&!in_array($mypad,$mypads)) {
                            array_push($tmp,$mypad);
                        }
                    }
                }

                $mypadshareds =$em      ->createQueryBuilder()
                                        ->select('e')
                                        ->from('CadolesCoreBundle:Etherpad','e')
                                        ->andWhere(':user MEMBER OF e.users')
                                        ->setParameter('user',$user)
                                        ->getQuery()->getResult();
                foreach($mypadshareds as $mypad) {
                    if(!in_array($mypad,$tmp)&&!in_array($mypad,$mypads)) {
                        array_push($tmp,$mypad);
                    }
                }
                        
                $mypadgroups=$tmp;

                // Calc
                $tmp=[];
                foreach($mycalcgroups as $mycalcgroup) {
                    foreach($mycalcgroup as $mycalc) {
                        if(!in_array($mycalc,$tmp)&&!in_array($mycalc,$mycalcs)) {
                            array_push($tmp,$mycalc);
                        }
                    }
                }

                $mycalcshareds =$em     ->createQueryBuilder()
                                        ->select('e')
                                        ->from('CadolesCoreBundle:Ethercalc','e')
                                        ->andWhere(':user MEMBER OF e.users')
                                        ->setParameter('user',$user)
                                        ->getQuery()->getResult();
                foreach($mycalcshareds as $mycalc) {
                    if(!in_array($mycalc,$tmp)&&!in_array($mycalc,$mycalcs)) {
                        array_push($tmp,$mycalc);
                    }
                }
                        
                $mycalcgroups=$tmp;
            }
        }

        return $this->render('CadolesCoreBundle:Core:home.html.twig',[
            'useheader'     => true,
            'usemenu'       => false,
            'usesidebar'    => false,              
            'myscrums'      => $myscrums,
            'myscrumgroups' => $myscrumgroups,
            'mypads'        => $mypads,
            'mypadgroups'   => $mypadgroups,
            'mycalcs'       => $mycalcs,
            'mycalcgroups'  => $mycalcgroups,
        ]);
    }
}
