<?php

namespace Cadoles\CoreBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;
use Symfony\Component\Validator\Constraints as Assert;

/**
 * Scrum
 *
 * @ORM\Entity
 * @ORM\Table(name="scrumwidget")
 * @ORM\HasLifecycleCallbacks
 */
class Scrumwidget
{
    /**
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;

    /**
     * @ORM\Column(name="name", type="string", length=100)
     */
    private $title;

    /**
     * @ORM\Column(name="description", type="text", nullable=true)
     */
    private $description;

    /**
     * @ORM\Column(name="roworder", type="integer")
     */
    private $roworder;

    /**
     * @ORM\ManyToOne(targetEntity="Scrumcolumn", inversedBy="scrumwidgets")
     */
    private $scrumcolumn;





    /**
     * Get id
     *
     * @return integer
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set title
     *
     * @param string $title
     *
     * @return Scrumwidget
     */
    public function setTitle($title)
    {
        $this->title = $title;

        return $this;
    }

    /**
     * Get title
     *
     * @return string
     */
    public function getTitle()
    {
        return $this->title;
    }

    /**
     * Set description
     *
     * @param string $description
     *
     * @return Scrumwidget
     */
    public function setDescription($description)
    {
        $this->description = $description;

        return $this;
    }

    /**
     * Get description
     *
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * Set roworder
     *
     * @param integer $roworder
     *
     * @return Scrumwidget
     */
    public function setRoworder($roworder)
    {
        $this->roworder = $roworder;

        return $this;
    }

    /**
     * Get roworder
     *
     * @return integer
     */
    public function getRoworder()
    {
        return $this->roworder;
    }

    /**
     * Set scrumcolumn
     *
     * @param \Cadoles\CoreBundle\Entity\Scrumcolumn $scrumcolumn
     *
     * @return Scrumwidget
     */
    public function setScrumcolumn(\Cadoles\CoreBundle\Entity\Scrumcolumn $scrumcolumn = null)
    {
        $this->scrumcolumn = $scrumcolumn;

        return $this;
    }

    /**
     * Get scrumcolumn
     *
     * @return \Cadoles\CoreBundle\Entity\Scrumcolumn
     */
    public function getScrumcolumn()
    {
        return $this->scrumcolumn;
    }
}
